<?php

/**
 * Reminder plugin
 *
 *
 * Created: 2007-02-20
 * Last update: 2007-03-10
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

function plugins_reminder_print_user_list( $p_user_ids ) {
    $t_mantis_project_user_list_table = config_get( 'mantis_project_user_list_table' );
    $t_mantis_user_table = config_get( 'mantis_user_table' );
    
    $query = "SELECT DISTINCT u.id, u.username, u.realname
				FROM $t_mantis_user_table u
				LEFT JOIN $t_mantis_project_user_list_table p
				ON p.user_id=u.id AND p.project_id='0'
				WHERE 	u.enabled = 1 AND
					p.user_id IS NULL
				ORDER BY u.realname, u.username";
    $result = db_query( $query );
    $t_display = array();
    $t_sort = array();
    $t_users = array();
    $t_show_realname = ( ON == config_get( 'show_realname' ) );
    $t_sort_by_last_name = ( ON == config_get( 'sort_by_last_name' ) );
    $category_count = db_num_rows( $result );
    for ($i=0;$i<$category_count;$i++) {
        $row = db_fetch_array( $result );
        $t_users[] = $row['id'];
        $t_user_name = string_attribute( $row['username'] );
        $t_sort_name = $t_user_name;
        if ( ( isset( $row['realname'] ) ) && ( $row['realname'] <> "" ) && $t_show_realname ) {
            $t_user_name = string_attribute( $row['realname'] );
            if ( $t_sort_by_last_name ) {
                $t_sort_name_bits = split( ' ', strtolower( $t_user_name ), 2 );
                $t_sort_name = ( isset( $t_sort_name_bits[1] ) ? $t_sort_name_bits[1] . ', ' : '' ) . $t_sort_name_bits[0];
            } else {
                $t_sort_name = strtolower( $t_user_name );
            }
        }
        $t_display[] = $t_user_name;
        $t_sort[] = $t_sort_name;
    }
    array_multisort( $t_sort, SORT_ASC, SORT_STRING, $t_users, $t_display );
    for ($i = 0; $i < count( $t_sort ); $i++ ) {
        echo '            <option value="' . $t_users[$i] . '"';
        if ( in_array( $t_users[$i], $p_user_ids ) ) {
            echo ' selected="selected"';
        }       
        echo '>' . $t_display[$i] . '</option>' . "\n";
    }
}

function plugins_reminder_print_custom_fields_option_list( $p_project_id, $p_selected ) {
    if ( $p_project_id == ALL_PROJECTS ) {
        return;
    }

    $t_mantis_custom_field_table = config_get( 'mantis_custom_field_table' );
    $t_mantis_custom_field_project_table = config_get( 'mantis_custom_field_project_table' );
    $c_project_id = db_prepare_int( $p_project_id );
    $t_query = 'SELECT c.id, c.name FROM ' . $t_mantis_custom_field_table . ' c LEFT JOIN ' . $t_mantis_custom_field_project_table . ' p ON c.id=p.field_id WHERE c.type=' . CUSTOM_FIELD_TYPE_DATE . ' AND p.project_id=' . $c_project_id;
    $t_result = db_query( $t_query );
    
    while( $t_row = db_fetch_array( $t_result ) ) {
        echo '            <option value="' . $t_row['id'] . '"';
        if ( $t_row['id'] == $p_selected ) {
            echo ' selected="selected"';
        }
        echo '>' . $t_row['name'] . '</option>' . "\n";
    }   
}

?>
