<?php

/**
 * Reminder plugin
 *
 *
 * Created: 2007-02-04
 * Last update: 2007-03-10
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_page.php', $_SERVER['REQUEST_URI'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_action = gpc_get_string( 'action', 'none' );
if ( $t_action == 'update' ) {
    $t_project_id = gpc_get_int( 'project_id' );
    $t_enable = gpc_get_bool( 'enable' );
    $t_html_enable = gpc_get_bool( 'html_enable' );
    $t_html_host = gpc_get_string( 'html_host', '' );
    $t_format = gpc_get_int( 'format' );
    $t_subject = gpc_get_string( 'subject' );
    $t_user_ids = gpc_get_int_array( 'user_id' );
    $t_bugs_id = gpc_get_string( 'bugs_id', PLUGINS_REMINDER_BUGS_ID_DEFAULT );
    $t_custom_field = gpc_get_int( 'custom_field' );
    $t_dates = str_replace( "\n", ';', gpc_get_string( 'dates', PLUGINS_REMINDER_DATES_DEFAULT ) );
    $t_boxes = array();
    $t_boxes['assigned'] = gpc_get_int( 'assigned' ) . ',' . str_replace( ',', ';', gpc_get_string( 'assigned_first' ) ) . ',' . gpc_get_int( 'assigned_second' );
    $t_boxes['feedback'] = gpc_get_int( 'feedback' ) . ',' . str_replace( ',', ';', gpc_get_string( 'feedback_first' ) ) . ',' . gpc_get_int( 'feedback_second' );
    $t_boxes['unassigned'] = gpc_get_int( 'unassigned' ) . ',' . str_replace( ',', ';', gpc_get_string( 'unassigned_first' ) ) . ',' . gpc_get_int( 'unassigned_second' );
    $t_boxes['deadline'] = gpc_get_int( 'deadline' ) . ',' . str_replace( ',', ';', gpc_get_string( 'deadline_first' ) ) . ',' . gpc_get_int( 'deadline_second' );
    config_set( 'plugins_reminder_enable', $t_enable, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_html_enable', $t_html_enable, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_html_host', $t_html_host, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_format', $t_format, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_subject_title', $t_subject, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_users', $t_user_ids, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_view_boxes', $t_boxes, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_bugs_id', $t_bugs_id, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_dates', $t_dates, NO_USER, $t_project_id );
    config_set( 'plugins_reminder_custom_field', $t_custom_field, NO_USER, $t_project_id );
    header( 'Location: plugins_page.php?plugin=reminder' );
    exit();
}

$t_project_id = helper_get_current_project();

$t_boxes = config_get( 'plugins_reminder_view_boxes', array( 'assigned' => PLUGINS_REMINDER_ASSIGNED_DEFAULT, 'unassigned' => PLUGINS_REMINDER_UNASSIGNED_DEFAULT, 'feedback' => PLUGINS_REMINDER_FEEDBACK_DEFAULT, 'deadline' => PLUGINS_REMINDER_DEADLINE_DEFAULT ) );
$t_box = array();
foreach( $t_boxes as $t_key => $t_value ) {
    $t_value = explode( ',', $t_value );
    $t_box[$t_key]['position'] = $t_value[0];
    $t_box[$t_key]['first'] = str_replace( ';', ',', $t_value[1] );
    $t_box[$t_key]['second'] = $t_value[2];
}

html_page_top1( lang_get( 'plugins_reminder_page_title' ) );
html_page_top2();

echo "\n\n";
echo "<br />\n<div align=\"center\">\n";
echo '  ' . str_replace( '%%project%%', '<b>' . project_get_name( helper_get_current_project() ) . '</b>', lang_get( 'plugins_reminder_configuration_for_project' ) ) . "\n";

?>
  <br /><br />
  <form name="plugins_reminder" method="post" action="plugins_page.php">
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
    <input type="hidden" name="plugin" value="reminder" />
    <table class="width75" cellspacing="1">

      <!-- Enable/Disable -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_enable' ) ?>
        </td>
        <td width="70%">
          <input tabindex="1" type="checkbox" name="enable"<?php check_checked( config_get( 'plugins_reminder_enable', PLUGINS_REMINDER_ENABLE_DEFAULT ), ON ) ?> />
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Send by browsing -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_allow_sending_by_html' ) ?>
        </td>
        <td width="70%">
          <input tabindex="2" type="checkbox" name="html_enable"<?php check_checked( config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT ), ON ) ?> />
        </td>
      </tr>

      <!-- From host -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <?php echo lang_get( 'plugins_reminder_from_host' ) ?>
        </td>
        <td width="70%">
          <input tabindex="3" type="input" name="html_host" value="<?php echo config_get( 'plugins_reminder_html_host', PLUGINS_REMINDER_HTML_HOST_DEFAULT ) ?>" />
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Format -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_format' ) ?>
        </td>
        <td width="70%">
          <select tabindex="4" name="format">
            <option value="0"<?php check_selected( config_get( 'plugins_reminder_format', PLUGINS_REMINDER_FORMAT_DEFAULT ), REMINDER_TEXT ) ?>>Text</option>
            <option value="1"<?php check_selected( config_get( 'plugins_reminder_format', PLUGINS_REMINDER_FORMAT_DEFAULT ), REMINDER_HTML ) ?>>HTML (<?php echo lang_get( 'plugins_reminder_not_recommended' ) ?>)</option>
            <option value="2"<?php check_selected( config_get( 'plugins_reminder_format', PLUGINS_REMINDER_FORMAT_DEFAULT ), REMINDER_TEXT_HTML ) ?>>Text/HTML</option>
          </select>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Subject -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_email_subject' ) ?>
        </td>
        <td width="70%">
          <input tabindex="5" type="input" name="subject" size="50" value="<?php echo config_get( 'plugins_reminder_subject_title', PLUGINS_REMINDER_SUBJECT_TITLE_DEFAULT ) ?>" />
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_assigned' ) ?>
        </td>
        <td width="70%">
          <ul>
            <li><b><?php echo lang_get( 'plugins_reminder_box_position' ) ?><input tabindex="6" type="input" name="assigned" size="3" value="<?php echo $t_box['assigned']['position'] ?>" /></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_first_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="7" type="input" name="assigned_first" size="6" value="<?php echo $t_box['assigned']['first'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_second_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="8" type="input" name="assigned_second" size="3" value="<?php echo $t_box['assigned']['second'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
          </ul>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_feedback' ) ?>
        </td>
        <td width="70%">
          <ul>
            <li><b><?php echo lang_get( 'plugins_reminder_box_position' ) ?><input tabindex="9" type="input" name="feedback" size="3" value="<?php echo $t_box['feedback']['position'] ?>" /></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_first_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="10" type="input" name="feedback_first" size="6" value="<?php echo $t_box['feedback']['first'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_second_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="11" type="input" name="feedback_second" size="3" value="<?php echo $t_box['feedback']['second'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
          </ul>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_unassigned' ) ?>
        </td>
        <td width="70%">
          <ul>
            <li><b><?php echo lang_get( 'plugins_reminder_box_position' ) ?><input tabindex="12" type="input" name="unassigned" size="3" value="<?php echo $t_box['unassigned']['position'] ?>" /></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_first_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="13" type="input" name="unassigned_first" size="6" value="<?php echo $t_box['unassigned']['first'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_second_date' ) . lang_get( 'plugins_reminder_after' ) ?><input tabindex="14" type="input" name="unassigned_second" size="3" value="<?php echo $t_box['unassigned']['second'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
          </ul>
        </td>
      </tr>

      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_deadline' ) ?>
        </td>
        <td width="70%">
          <ul>
            <li><b><?php echo lang_get( 'plugins_reminder_box_position' ) ?><input tabindex="15" type="input" name="deadline" size="3" value="<?php echo $t_box['deadline']['position'] ?>" /></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_first_date' ) ?><input tabindex="16" type="input" name="deadline_first" size="6" value="<?php echo $t_box['deadline']['first'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) . ' '  . lang_get( 'plugins_reminder_before_deadline' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
            <li><b><?php echo lang_get( 'plugins_reminder_second_date' ) ?><input tabindex="17" type="input" name="deadline_second" size="3" value="<?php echo $t_box['deadline']['second'] ?>" /> <?php echo lang_get( 'plugins_reminder_days' ) . ' '  . lang_get( 'plugins_reminder_before_deadline' ) ?></b> (<?php echo lang_get( 'plugins_reminder_zero_to_disable' ) ?>)</li>
          </ul>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Deadline feature -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_deadline_custom_field' ) ?>
        </td>
        <td width="70%">
          <select tabindex="18" name="custom_field">
            <option value="0"<?php check_selected( config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT ), 0 ) ?>>&nbsp;</option>
<?php plugins_reminder_print_custom_fields_option_list( $t_project_id, config_get( 'plugins_reminder_custom_field', PLUGINS_REMINDER_CUSTOM_FIELD_DEFAULT ) ) ?>
          </select>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Exclude bugs -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <?php echo lang_get( 'plugins_reminder_exclude_bugs' ) ?>
        </td>
        <td width="70%">
          <textarea tabindex="19" name="bugs_id" rows="5" cols="50"><?php echo config_get( 'plugins_reminder_bugs_id', PLUGINS_REMINDER_BUGS_ID_DEFAULT ) ?></textarea>
        </td>
      </tr>

      <!-- Exclude dates -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <?php echo lang_get( 'plugins_reminder_exclude_dates' ) ?>
        </td>
        <td width="70%">
          <textarea tabindex="20" name="dates" rows="5" cols="50"><?php echo str_replace( ';', "\n", config_get( 'plugins_reminder_dates', PLUGINS_REMINDER_DATES_DEFAULT ) ) ?></textarea>
        </td>
      </tr>

      <!-- spacer -->
      <tr>
        <td class="spacer" colspan="2">&nbsp;</td>
      </tr>

      <!-- Send to -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_reminder_send_to' ) ?>
        </td>
        <td width="70%">
          <select tabindex="21" name="user_id[]" multiple="multiple" size="10">
<?php plugins_reminder_print_user_list( config_get( 'plugins_reminder_users', array() ) ) ?>
          </select>
        </td>
      </tr>

      <!-- Submit Button -->
      <tr>
        <td class="left">
          <span class="required"> * <?php echo lang_get( 'required' ) ?></span>
        </td>
        <td class="center">
          <input tabindex="22" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />
        </td>
      </tr>
    </table>
  </form>

<?php

if ( config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT, NO_USER, ALL_PROJECTS ) == ON || config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT, NO_USER, $t_project_id ) == ON ) {

?>
  <br />
  <table class="width75" cellspacing="1">
    <tr>
      <td class="form-title"><?php echo lang_get( 'plugins_reminder_links_to_send' )  ?></td>
    </tr>
      <td class="center">
<?php

$t_ip = config_get( 'plugins_reminder_html_host', PLUGINS_REMINDER_HTML_HOST_DEFAULT, NO_USER, $t_project_id );
if ( !eregi( '^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+', $t_ip ) ) {
    $t_ip = gethostbyname( $t_ip );
}
$t_insert_br = '';
if ( config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT, NO_USER, $t_project_id ) == ON && $_SERVER['REMOTE_ADDR'] == $t_ip ) {
    echo '        <a href="plugins/reminder/reminder_send.php?project_id=' . $t_project_id . '">' . lang_get( 'plugins_reminder_send_project_link' ) . '</a> [<a href="plugins/reminder/reminder_send.php?project_id=' . $t_project_id . '" target="_blank">^</a>]';
    $t_insert_br = '<br />' . "\n";
}
$t_ip = config_get( 'plugins_reminder_html_host', PLUGINS_REMINDER_HTML_HOST_DEFAULT, NO_USER, ALL_PROJECTS );
if ( !eregi( '^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+', $t_ip ) ) {
    $t_ip = gethostbyname( $t_ip );
}
if ( config_get( 'plugins_reminder_html_enable', PLUGINS_REMINDER_HTML_ENABLE_DEFAULT, NO_USER, ALL_PROJECTS ) == ON && $_SERVER['REMOTE_ADDR'] == $t_ip ) {
    echo $t_insert_br;
    echo '        <a href="plugins/reminder/reminder_send.php">' . lang_get( 'plugins_reminder_send_all_project_link' ) . '</a> [<a href="plugins/reminder/reminder_send.php" target="_blank">^</a>]';
}

?>
      </td>
    <tr>
    </tr>
  </table>
<?php

}

echo "</div>\n";

html_page_bottom1( __FILE__ );

?>
